"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
/**
 * Utility for navigator.
 */
class NavigatorUtility {
    /**
     * Returns the package version.
     *
     * @returns Package version.
     */
    static getHappyDOMVersion() {
        const content = fs_1.default.readFileSync(path_1.default.join(__dirname, '..', '..', 'package.json')).toString();
        const json = JSON.parse(content);
        return json.version;
    }
    /**
     * Returns platform.
     *
     * @returns Platform.
     */
    static getPlatform() {
        const platform = process.platform;
        const platformCapitalized = platform.charAt(0).toUpperCase() + platform.slice(1);
        return 'X11; ' + platformCapitalized + ' ' + process.arch;
    }
}
exports.default = NavigatorUtility;
//# sourceMappingURL=NavigatorUtility.cjs.map